=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpRpmClient
  class ContentModulemdDefaultsApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Create a modulemd defaults
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param _module [String] Modulemd name.
    # @param stream [String] Modulemd default stream.
    # @param profiles [Object] Default profiles for modulemd streams.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @return [AsyncOperationResponse]
    def create(relative_path, _module, stream, profiles, opts = {})
      data, _status_code, _headers = create_with_http_info(relative_path, _module, stream, profiles, opts)
      data
    end

    # Create a modulemd defaults
    # Trigger an asynchronous task to create content,optionally create new repository version.
    # @param relative_path [String] Path where the artifact is located relative to distributions base_path
    # @param _module [String] Modulemd name.
    # @param stream [String] Modulemd default stream.
    # @param profiles [Object] Default profiles for modulemd streams.
    # @param [Hash] opts the optional parameters
    # @option opts [String] :artifact Artifact file representing the physical content
    # @option opts [File] :file An uploaded file that may be turned into the artifact of the content unit.
    # @option opts [String] :repository A URI of a repository the new content unit should be associated with.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def create_with_http_info(relative_path, _module, stream, profiles, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentModulemdDefaultsApi.create ...'
      end
      # verify the required parameter 'relative_path' is set
      if @api_client.config.client_side_validation && relative_path.nil?
        fail ArgumentError, "Missing the required parameter 'relative_path' when calling ContentModulemdDefaultsApi.create"
      end
      # verify the required parameter '_module' is set
      if @api_client.config.client_side_validation && _module.nil?
        fail ArgumentError, "Missing the required parameter '_module' when calling ContentModulemdDefaultsApi.create"
      end
      # verify the required parameter 'stream' is set
      if @api_client.config.client_side_validation && stream.nil?
        fail ArgumentError, "Missing the required parameter 'stream' when calling ContentModulemdDefaultsApi.create"
      end
      # verify the required parameter 'profiles' is set
      if @api_client.config.client_side_validation && profiles.nil?
        fail ArgumentError, "Missing the required parameter 'profiles' when calling ContentModulemdDefaultsApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/modulemd_defaults/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['relative_path'] = relative_path
      form_params['module'] = _module
      form_params['stream'] = stream
      form_params['profiles'] = profiles
      form_params['artifact'] = opts[:'artifact'] if !opts[:'artifact'].nil?
      form_params['file'] = opts[:'file'] if !opts[:'file'].nil?
      form_params['repository'] = opts[:'repository'] if !opts[:'repository'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentModulemdDefaultsApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List modulemd defaultss
    # ViewSet for Modulemd.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :_module Filter results where module matches value
    # @option opts [Array<String>] :module__in Filter results where module is in a comma-separated list of values
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 
    # @option opts [String] :stream Filter results where stream matches value
    # @option opts [Array<String>] :stream__in Filter results where stream is in a comma-separated list of values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedrpmModulemdDefaultsResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List modulemd defaultss
    # ViewSet for Modulemd.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :_module Filter results where module matches value
    # @option opts [Array<String>] :module__in Filter results where module is in a comma-separated list of values
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :repository_version Repository Version referenced by HREF
    # @option opts [String] :repository_version_added Repository Version referenced by HREF
    # @option opts [String] :repository_version_removed Repository Version referenced by HREF
    # @option opts [String] :sha256 
    # @option opts [String] :stream Filter results where stream matches value
    # @option opts [Array<String>] :stream__in Filter results where stream is in a comma-separated list of values
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedrpmModulemdDefaultsResponseList, Integer, Hash)>] PaginatedrpmModulemdDefaultsResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentModulemdDefaultsApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/content/rpm/modulemd_defaults/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'module'] = opts[:'_module'] if !opts[:'_module'].nil?
      query_params[:'module__in'] = @api_client.build_collection_param(opts[:'module__in'], :csv) if !opts[:'module__in'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'repository_version'] = opts[:'repository_version'] if !opts[:'repository_version'].nil?
      query_params[:'repository_version_added'] = opts[:'repository_version_added'] if !opts[:'repository_version_added'].nil?
      query_params[:'repository_version_removed'] = opts[:'repository_version_removed'] if !opts[:'repository_version_removed'].nil?
      query_params[:'sha256'] = opts[:'sha256'] if !opts[:'sha256'].nil?
      query_params[:'stream'] = opts[:'stream'] if !opts[:'stream'].nil?
      query_params[:'stream__in'] = @api_client.build_collection_param(opts[:'stream__in'], :csv) if !opts[:'stream__in'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedrpmModulemdDefaultsResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentModulemdDefaultsApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a modulemd defaults
    # ViewSet for Modulemd.
    # @param rpm_modulemd_defaults_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [RpmModulemdDefaultsResponse]
    def read(rpm_modulemd_defaults_href, opts = {})
      data, _status_code, _headers = read_with_http_info(rpm_modulemd_defaults_href, opts)
      data
    end

    # Inspect a modulemd defaults
    # ViewSet for Modulemd.
    # @param rpm_modulemd_defaults_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(RpmModulemdDefaultsResponse, Integer, Hash)>] RpmModulemdDefaultsResponse data, response status code and response headers
    def read_with_http_info(rpm_modulemd_defaults_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: ContentModulemdDefaultsApi.read ...'
      end
      # verify the required parameter 'rpm_modulemd_defaults_href' is set
      if @api_client.config.client_side_validation && rpm_modulemd_defaults_href.nil?
        fail ArgumentError, "Missing the required parameter 'rpm_modulemd_defaults_href' when calling ContentModulemdDefaultsApi.read"
      end
      # resource path
      local_var_path = '{rpm_modulemd_defaults_href}'.sub('{' + 'rpm_modulemd_defaults_href' + '}', CGI.escape(rpm_modulemd_defaults_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'RpmModulemdDefaultsResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: ContentModulemdDefaultsApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
