=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'date'

module PulpRpmClient
  # Modulemd serializer.
  class RpmModulemd
    # Artifact file representing the physical content
    attr_accessor :artifact

    # Path where the artifact is located relative to distributions base_path
    attr_accessor :relative_path

    # An uploaded file that may be turned into the artifact of the content unit.
    attr_accessor :file

    # A URI of a repository the new content unit should be associated with.
    attr_accessor :repository

    # Modulemd name.
    attr_accessor :name

    # Stream name.
    attr_accessor :stream

    # Modulemd version.
    attr_accessor :version

    # Modulemd static-context flag.
    attr_accessor :static_context

    # Modulemd context.
    attr_accessor :context

    # Modulemd architecture.
    attr_accessor :arch

    # Modulemd artifacts.
    attr_accessor :artifacts

    # Modulemd dependencies.
    attr_accessor :dependencies

    # Modulemd artifacts' packages.
    attr_accessor :packages

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'artifact' => :'artifact',
        :'relative_path' => :'relative_path',
        :'file' => :'file',
        :'repository' => :'repository',
        :'name' => :'name',
        :'stream' => :'stream',
        :'version' => :'version',
        :'static_context' => :'static_context',
        :'context' => :'context',
        :'arch' => :'arch',
        :'artifacts' => :'artifacts',
        :'dependencies' => :'dependencies',
        :'packages' => :'packages'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'artifact' => :'String',
        :'relative_path' => :'String',
        :'file' => :'File',
        :'repository' => :'String',
        :'name' => :'String',
        :'stream' => :'String',
        :'version' => :'String',
        :'static_context' => :'Boolean',
        :'context' => :'String',
        :'arch' => :'String',
        :'artifacts' => :'Object',
        :'dependencies' => :'Object',
        :'packages' => :'Array<String>'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
        :'artifacts',
        :'dependencies',
      ])
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `PulpRpmClient::RpmModulemd` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `PulpRpmClient::RpmModulemd`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'artifact')
        self.artifact = attributes[:'artifact']
      end

      if attributes.key?(:'relative_path')
        self.relative_path = attributes[:'relative_path']
      end

      if attributes.key?(:'file')
        self.file = attributes[:'file']
      end

      if attributes.key?(:'repository')
        self.repository = attributes[:'repository']
      end

      if attributes.key?(:'name')
        self.name = attributes[:'name']
      end

      if attributes.key?(:'stream')
        self.stream = attributes[:'stream']
      end

      if attributes.key?(:'version')
        self.version = attributes[:'version']
      end

      if attributes.key?(:'static_context')
        self.static_context = attributes[:'static_context']
      end

      if attributes.key?(:'context')
        self.context = attributes[:'context']
      end

      if attributes.key?(:'arch')
        self.arch = attributes[:'arch']
      end

      if attributes.key?(:'artifacts')
        self.artifacts = attributes[:'artifacts']
      end

      if attributes.key?(:'dependencies')
        self.dependencies = attributes[:'dependencies']
      end

      if attributes.key?(:'packages')
        if (value = attributes[:'packages']).is_a?(Array)
          self.packages = value
        end
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @relative_path.nil?
        invalid_properties.push('invalid value for "relative_path", relative_path cannot be nil.')
      end

      if @name.nil?
        invalid_properties.push('invalid value for "name", name cannot be nil.')
      end

      if @stream.nil?
        invalid_properties.push('invalid value for "stream", stream cannot be nil.')
      end

      if @version.nil?
        invalid_properties.push('invalid value for "version", version cannot be nil.')
      end

      if @context.nil?
        invalid_properties.push('invalid value for "context", context cannot be nil.')
      end

      if @arch.nil?
        invalid_properties.push('invalid value for "arch", arch cannot be nil.')
      end

      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @relative_path.nil?
      return false if @name.nil?
      return false if @stream.nil?
      return false if @version.nil?
      return false if @context.nil?
      return false if @arch.nil?
      true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          artifact == o.artifact &&
          relative_path == o.relative_path &&
          file == o.file &&
          repository == o.repository &&
          name == o.name &&
          stream == o.stream &&
          version == o.version &&
          static_context == o.static_context &&
          context == o.context &&
          arch == o.arch &&
          artifacts == o.artifacts &&
          dependencies == o.dependencies &&
          packages == o.packages
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [artifact, relative_path, file, repository, name, stream, version, static_context, context, arch, artifacts, dependencies, packages].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        PulpRpmClient.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end
        
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end
  end
end
